program PB009DirectX;

uses
  ExceptionLog,

  Forms,          // include TForm
  ExtCtrls,       // include TTimer
  Windows,        // include FAILED & SUCCEEDED
  Messages,       // include WM_QUIT message
  Dialogs,        // include MessageDlg

  Direct3D9 in 'DirectX\Direct3D9.pas',
  D3DX9 in 'DirectX\D3DX9.pas';





{$R *.res}
{$R *.dfm}





type
  // Custom vertices for primitives using vertex alpha.
{  TRANSCUSTOMVERTEXSTRUCT = packed record
    coords: D3DVECTOR;
    normal: D3DVECTOR;
    dwColor: Integer;
    tu, tv: Single;
  end;}
  TRANSCUSTOMVERTEXSTRUCT = array [0..8] of Single;


  // Custom vertices for primitives NOT using vertex alpha blending.
{  CUSTOMVERTEXSTRUCT = packed record
    coords: D3DVECTOR;
    normal: D3DVECTOR;
    tu, tv: Single;
  end;}
  CUSTOMVERTEXSTRUCT = array [0..7] of Single;


  // Hlavni formular
  TForm1 = class(TForm)
  private
    TransparentTexture: IDirect3DTexture9;
    TextureA: IDirect3DTexture9;
    TextureB: IDirect3DTexture9;
    TextureC: IDirect3DTexture9;
    TextureStar: IDirect3DTexture9;
    TexturePillar: IDirect3DTexture9;
    TextureWelcome: IDirect3DTexture9;
    TextureWelcome1: IDirect3DTexture9;
    TextureWelcome2: IDirect3DTexture9;
    TransparentSquareTexture: IDirect3DTexture9;
    BackgroundSurface: IDirect3DSurface9;

    VertexBuf: IDirect3DVertexBuffer9;
    TransparentSquareVertexBuf: IDirect3DVertexBuffer9;

    NumTriangles: Integer;
  protected
    Direct3D: IDirect3D9;
    Direct3DDevice: IDirect3DDevice9;
    BackBuffer: IDirect3DSurface9;
    function InitDirect3D: HRESULT;
    function InitVertices: HRESULT;
    function SetRenderingStates: HRESULT;
    function LoadTextures: HRESULT;
    function LoadBackgroundBitmap: HRESULT;
    function VytvorZarizeni: HRESULT;

    procedure DisplayBackgroundImage;

  public
    Timer: TTimer;
    procedure InitForm;
    procedure CleanUpDirect3D;

    procedure PohybSceny;
    procedure VykresleniSceny;

    procedure OnTimeTick(Sender: TObject);
    procedure OnIdle(Sender: TObject; var Done: Boolean);
  end;




var Kostka: array [0..35] of CUSTOMVERTEXSTRUCT =
    (
        // Predni strana krychle
        (-0.5,  0.5, -0.5, 0.0, 0.0, -1.0, 0.0, 0.0),
        ( 0.5, -0.5, -0.5, 0.0, 0.0, -1.0, 1.0, 1.0),
        (-0.5, -0.5, -0.5, 0.0, 0.0, -1.0, 0.0, 1.0),
        (-0.5,  0.5, -0.5, 0.0, 0.0, -1.0, 0.0, 0.0),
        ( 0.5,  0.5, -0.5, 0.0, 0.0, -1.0, 1.0, 0.0),
        ( 0.5, -0.5, -0.5, 0.0, 0.0, -1.0, 1.0, 1.0),

        // Prava strana krychle
        (0.5,  0.5, -0.5, 1.0, 0.0, 0.0, 0.0, 0.0),
        (0.5, -0.5,  0.5, 1.0, 0.0, 0.0, 1.0, 1.0),
        (0.5, -0.5, -0.5, 1.0, 0.0, 0.0, 0.0, 1.0),
        (0.5,  0.5, -0.5, 1.0, 0.0, 0.0, 0.0, 0.0),
        (0.5,  0.5,  0.5, 1.0, 0.0, 0.0, 1.0, 0.0),
        (0.5, -0.5,  0.5, 1.0, 0.0, 0.0, 1.0, 1.0),

        // Zadni strana krychle
        ( 0.5,  0.5, 0.5, 0.0, 0.0, 1.0, 0.0, 0.0),
        (-0.5, -0.5, 0.5, 0.0, 0.0, 1.0, 1.0, 1.0),
        ( 0.5, -0.5, 0.5, 0.0, 0.0, 1.0, 0.0, 1.0),
        ( 0.5,  0.5, 0.5, 0.0, 0.0, 1.0, 0.0, 0.0),
        (-0.5,  0.5, 0.5, 0.0, 0.0, 1.0, 1.0, 0.0),
        (-0.5, -0.5, 0.5, 0.0, 0.0, 1.0, 1.0, 1.0),

        // Leva strana krychle
        (-0.5,  0.5,  0.5, -1.0, 0.0, 0.0, 0.0, 0.0),
        (-0.5, -0.5, -0.5, -1.0, 0.0, 0.0, 1.0, 1.0),
        (-0.5, -0.5,  0.5, -1.0, 0.0, 0.0, 0.0, 1.0),
        (-0.5,  0.5,  0.5, -1.0, 0.0, 0.0, 0.0, 0.0),
        (-0.5,  0.5, -0.5, -1.0, 0.0, 0.0, 1.0, 0.0),
        (-0.5, -0.5, -0.5, -1.0, 0.0, 0.0, 1.0, 1.0),

        // Vrchni strana krychle
        (-0.5, 0.5, -0.5, 0.0, 1.0, 0.0, 0.0, 0.0),
        (-0.5, 0.5,  0.5, 0.0, 1.0, 0.0, 1.0, 0.0),
        ( 0.5, 0.5, -0.5, 0.0, 1.0, 0.0, 0.0, 1.0),
        (-0.5, 0.5,  0.5, 0.0, 1.0, 0.0, 1.0, 0.0),
        ( 0.5, 0.5,  0.5, 0.0, 1.0, 0.0, 1.0, 1.0),
        ( 0.5, 0.5, -0.5, 0.0, 1.0, 0.0, 0.0, 1.0),

        // Spodni strana krychle
        (-0.5, -0.5, -0.5, 0.0, -1.0, 0.0, 0.0, 0.0),
        ( 0.5, -0.5, -0.5, 0.0, -1.0, 0.0, 0.0, 1.0),
        (-0.5, -0.5,  0.5, 0.0, -1.0, 0.0, 1.0, 0.0),
        ( 0.5, -0.5, -0.5, 0.0, -1.0, 0.0, 0.0, 1.0),
        ( 0.5, -0.5,  0.5, 0.0, -1.0, 0.0, 1.0, 1.0),
        (-0.5, -0.5,  0.5, 0.0, -1.0, 0.0, 1.0, 0.0)
    );

  TransparentSquare: array [0..5] of TRANSCUSTOMVERTEXSTRUCT =
    (
        ( 0.75,  0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 0.0, 0.0),
        (-0.75, -0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 1.0, 1.0),
        ( 0.75, -0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 0.0, 1.0),
        ( 0.75,  0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 0.0, 0.0),
        (-0.75,  0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 1.0, 0.0),
        (-0.75, -0.75, 0.2, 0.0, 0.0, 1.0,
            -9999, 1.0, 1.0)
    );



//--------------------------------------------------------------------------
// Hlavni metody
//--------------------------------------------------------------------------

procedure TForm1.InitForm;
begin
  Timer := TTimer.Create(Self);
  Timer.Interval := 500;
  Timer.OnTimer := OnTimeTick;

  Application.OnIdle := OnIdle;

  if SUCCEEDED(InitDirect3D) then
    InitVertices;
end;


procedure TForm1.OnTimeTick(Sender: TObject);
begin
  PohybSceny;
end;


procedure TForm1.OnIdle(Sender: TObject; var Done: Boolean);
begin
  VykresleniSceny;
  Done := True;
end;


procedure TForm1.CleanUpDirect3D;
begin
  if Direct3DDevice <> nil then
    Direct3DDevice := nil;    // stands for Direct3DDevice._Release();

  if Direct3D <> nil then
    Direct3D := nil;          // stands for Direct3D._Release();
end;











//--------------------------------------------------------------------------
// Inicializace Direct3D
//--------------------------------------------------------------------------

function TForm1.InitDirect3D: HRESULT;
var
  lTmp: HRESULT;
begin
  Result := E_FAIL;

	// Create the main Direct3D object
  Direct3D := Direct3DCreate9(D3D_SDK_VERSION);
  if (Direct3D = nil) then begin
    MessageDlg('Couldn''t create main Direct3D object.', mtWarning, [mbOK], 0);
    Exit;
  end;

	// Create the Direct3D device
	if (FAILED(VytvorZarizeni)) then begin
    MessageDlg('Couldn''t create main Direct3D device.', mtWarning, [mbOK], 0);
    Exit;
  end;

  //---------

  // Set global rendering states
  if FAILED(SetRenderingStates) then begin
    MessageDlg('Couldn''t set rendering states.', mtWarning, [mbOK], 0);
    PostQuitMessage(WM_QUIT);
    Exit;
  end;


  // Load the textures
  if FAILED(LoadTextures()) then begin
    MessageDlg('Couldn''t load textures.', mtWarning, [mbOK], 0);
    PostQuitMessage(WM_QUIT);
    Exit;
  end;
  // Nastav prvni texturu pro animovany napis na zacatku
  TextureWelcome := TextureWelcome1;


  // Nahraj pozadi
  if FAILED(LoadBackgroundBitmap) then begin
    MessageDlg('Couldn''t load background bitmap.', mtWarning, [mbOK], 0);
    Exit;
  end;

  //---------

  lTmp := Direct3DDevice.GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, BackBuffer);
  if FAILED(lTmp) then begin
    MessageDlg('Couldn''t acquire back buffer.', mtWarning, [mbOK], 0);
    Exit;
  end;

  Result := D3D_OK;
end;


function TForm1.VytvorZarizeni: HRESULT;
var
  D3DPresentParams: D3DPRESENT_PARAMETERS;
begin
  FillMemory(@D3DPresentParams, SizeOf(D3DPRESENT_PARAMETERS), 0);
  D3DPresentParams.Windowed := TRUE;
  D3DPresentParams.BackBufferFormat := D3DFMT_UNKNOWN;
  D3DPresentParams.SwapEffect := D3DSWAPEFFECT_DISCARD;
  D3DPresentParams.hDeviceWindow := Handle;
  D3DPresentParams.EnableAutoDepthStencil := True;
  D3DPresentParams.AutoDepthStencilFormat := D3DFMT_D16;

  Result := Direct3D.CreateDevice(D3DADAPTER_DEFAULT,
              D3DDEVTYPE_HAL,
              Application.Handle,
              D3DCREATE_SOFTWARE_VERTEXPROCESSING,
              @D3DPresentParams,
              Direct3DDevice);
end;


function TForm1.LoadBackgroundBitmap: HRESULT;
begin
  Result := E_FAIL;

  // Create a surface for the background bitmap
  if FAILED(Direct3DDevice.CreateOffscreenPlainSurface(800, 600,
            D3DFMT_X8R8G8B8, D3DPOOL_DEFAULT, BackgroundSurface, nil)) then
    Exit;

  // Load the background bitmap into the surface.
  if FAILED(D3DXLoadSurfaceFromFile(BackgroundSurface, nil, nil,
            'Background.bmp', nil, D3DX_DEFAULT, 0, nil)) then
    Exit;

  Result := D3D_OK;
end;


function TForm1.InitVertices: HRESULT;
var
  lNumCoordsPerVertex: Integer;
  pVertices: Pointer;
begin
  Result := E_FAIL;

  lNumCoordsPerVertex := 24;

  // Create the vertex buffer
  if FAILED(Direct3DDevice.CreateVertexBuffer(SizeOf(Kostka),
            0, D3DFVF_XYZ or D3DFVF_NORMAL or D3DFVF_TEX1, D3DPOOL_DEFAULT,
            VertexBuf, nil)) then
    Exit;

  if FAILED(VertexBuf.Lock( 0, 0, pVertices, 0)) then
    Exit;

  CopyMemory(pVertices, @Kostka, SizeOf(Kostka));
  VertexBuf.Unlock();

  NumTriangles := (SizeOf(Kostka) div SizeOf(Single)) div lNumCoordsPerVertex;


  if FAILED(Direct3DDevice.CreateVertexBuffer(SizeOf(TransparentSquare),
            0, D3DFVF_XYZ or D3DFVF_NORMAL or D3DFVF_DIFFUSE or D3DFVF_TEX1,
            D3DPOOL_DEFAULT, TransparentSquareVertexBuf, nil)) then
    Exit;
  if FAILED(TransparentSquareVertexBuf.Lock(0, 0, pVertices, 0)) then
    Exit;
  CopyMemory(pVertices, @Kostka, SizeOf(TransparentSquare));
  TransparentSquareVertexBuf.Unlock();

  Result := S_OK;
end;


function TForm1.SetRenderingStates: HRESULT;
begin
  Result := E_FAIL;

  // Set up Alpha blending
  if FAILED(Direct3DDevice.SetRenderState(D3DRS_SRCBLEND,
            D3DBLEND_SRCALPHA)) then
    Exit;
  if FAILED(Direct3DDevice.SetRenderState(D3DRS_DESTBLEND,
            D3DBLEND_INVSRCALPHA)) then
    Exit;

  // Setup the application for vertex alpha blending
  if FAILED(Direct3DDevice.SetRenderState(
            D3DRS_DIFFUSEMATERIALSOURCE, D3DMCS_COLOR1)) then
    Exit;

  // Set up alpha testing
  if FAILED(Direct3DDevice.SetRenderState(D3DRS_ALPHAREF, 96)) then
    Exit;
  if FAILED(Direct3DDevice.SetRenderState(D3DRS_ALPHAFUNC,
             D3DCMP_GREATEREQUAL)) then
    Exit;

  // Set up fog
  if FAILED(Direct3DDevice.SetRenderState(D3DRS_FOGVERTEXMODE,
            D3DFOG_EXP2)) then
    Exit;

  Result := D3D_OK;
end;



function TForm1.LoadTextures: HRESULT;
begin
  Result := E_FAIL;

  // Load texture with transparent areas (color key).
  if FAILED(D3DXCreateTextureFromFileEx(Direct3DDevice,
            'texture.bmp', D3DX_DEFAULT, D3DX_DEFAULT, D3DX_DEFAULT, 0,
            D3DFMT_A8R8G8B8, D3DPOOL_MANAGED, D3DX_FILTER_TRIANGLE,
            D3DX_FILTER_TRIANGLE, D3DCOLOR_RGBA(255,0,0,255),
            nil, nil, TransparentTexture)) then
    Exit;

  // Load remaining textures.
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_A.bmp', TextureA)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_B.bmp', TextureB)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_C.bmp', TextureC)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_Star.bmp', TextureStar)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'texture03.bmp', TransparentSquareTexture)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_Pillar.bmp', TexturePillar)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_Welcome1.bmp', TextureWelcome1)) then
    Exit;
  if FAILED(D3DXCreateTextureFromFile(Direct3DDevice,
          'Texture_Welcome2.bmp', TextureWelcome2)) then
    Exit;

  Result := D3D_OK;
end;











//--------------------------------------------------------------------------
//  Pohyb sveta
//--------------------------------------------------------------------------

procedure TForm1.PohybSceny;
begin
  //
end;











//--------------------------------------------------------------------------
//  Vykreslovani sveta
//--------------------------------------------------------------------------

procedure TForm1.VykresleniSceny;
begin
	// Clear the target surface
  Direct3DDevice.Clear(0, nil, D3DCLEAR_TARGET or D3DCLEAR_ZBUFFER,
        D3DCOLOR_XRGB(0,0,0), 1.0, 0);

  DisplayBackgroundImage();
//  SetVariableRenderStates();

{  // Render the 3D scene.
  if(SUCCEEDED(Direct3DDevice->BeginScene())) then
  begin
    InitLights();
    SetViewTransformation();
    SetProjectionTransformation();
    RenderTransparentCube();
    RenderSign();
    RenderCubeA();
    RenderCubeB();
    RenderCubeC();
    RenderStarCube();
    RenderTransparentRectangles();
    g_pDirect3DDevice->EndScene();
  end;}

	// Display the newly rendered scene.
  Direct3DDevice.Present( nil, nil, 0, nil );
end;




procedure TForm1.DisplayBackgroundImage;
var
  SrcRect, DstRect: TRect;
begin
  // Set up source and destination rectangles for the background blit.
  SrcRect.Left := 0;
  SrcRect.Top := 0;
  SrcRect.Right := 800;
  SrcRect.Bottom := 600;

  DstRect.Left := 0;
  DstRect.Top := 0;
  DstRect.Right := 800;
  DstRect.Bottom := 600;

  // Blit the background image to the target surface.
  Direct3DDevice.StretchRect(BackgroundSurface, @SrcRect,
                             BackBuffer, @DstRect, D3DTEXF_NONE);
end;















//--------------------------------------------------------------------------
//  Main() neboli hlavni smycka aplikace
//--------------------------------------------------------------------------

var
  Formular: TForm1;
  pom: Cardinal;
  pom2: ^Cardinal;
  i: Integer;

begin
  pom := D3DCOLOR_ARGB(96,255,255,255);
  pom2 := @TransparentSquare;
  Inc(pom2, 6);
  for i:=0 to 5 do begin
    pom2^ := pom;
    Inc(pom2, 9);
  end;

  Application.Initialize;
  Application.Title := 'PB009 Projekt Delphi Demo';
  Application.CreateForm(TForm1, Formular);

  Formular.InitForm;

  Application.Run;

  Formular.CleanUpDirect3D;
end.
